#!/usr/bin/env python
# -*- coding: utf-8 -*-

"""DocString

DocString Paragraph

"""

import pygtk
pygtk.require('2.0')
import gtk

import os
import apt
import shutil
from core.db import Database

class PluginBase(object):  
    value = False
    
class Window:

    def callback_o (self, widget, data=None):
        """ Change the value method of each plugin. 
        """
        #d = ("off", "on")[widget.get_active()]
        #print data.name + " " + str(d)
        self.value = widget.get_active()
        data.value = widget.get_active()
        
        
    def backup_click(self, widget, data=None):
        """ It's call for every sync() method on each plugin that has
        the value = True        
        """
        for op in self.options:
            print op.name
            if op.value:
                op.sync()

    def restore_click(self, widget, data=None):
        for op in self.options:                
            print op.name
            if op.value:
                op.restore()

    def delete_event(self, widget, event, data=None):
        gtk.main_quit()
        return False
        
    def __init__(self, options):
        self.options = options
        self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
        self.window.connect("delete_event", self.delete_event)
        self.window.set_border_width(20)
        vbox = gtk.VBox(True, 2)
        self.window.add(vbox)
        # Loading the buttons
        for op in options:
            button = gtk.CheckButton(op.name)
#            button.available = False
            button.connect("toggled", self.callback_o, op)
            vbox.pack_start(button, True, True, 0)
            button.show()
        
        ##Run Command Button ##
        button = gtk.Button("Make backup")
        button.connect("clicked", self.backup_click)
        vbox.pack_start(button, True, True, 0)
        button.show()

        ## Restore Command Button ##
        button = gtk.Button("Restore")
        button.connect("clicked", self.restore_click)
        vbox.pack_start(button, True, True, 2)
        button.show()

        vbox.show()
        self.window.show()

    def main(self):
        gtk.main()

def loadPlugins():
    """ Search for every *.py file, (except for: __init__.py and *.pyc)
    From each file, it's takes Plugin Class, instance it and retunr in
    in a list.
    """
    objetos = []
    files = (os.listdir("./plugins"))
    files.sort()
    for arch in files:
        if arch.startswith("_") or arch.endswith("pyc"):
            continue
        mod = __import__("plugins." + arch.split(".")[0])
        mod = getattr(mod, arch.split(".")[0])
        objetos.append(mod.Plugin())
    return objetos
    
def run():
    objetos = loadPlugins()
    window = Window(objetos)
    window.main()

if __name__ == "__main__":
    print __doc__

