#!/usr/bin/env python
# -*- coding: utf-8 -*-

"""DocString

DocString Paragraph

"""
import os
import commands
from desktopcouch.records.server import CouchDatabase
from desktopcouch.records.record import Record as CouchRecord
from core.stipple import PluginBase

database = CouchDatabase("packages", create=True)
databaserecord = ""
RECORD_TYPE = 'http://www.okiebuntu.homelinux.com/packagesync'
BASH_CONFIG = os.path.expanduser("~") + "/.bashrc"

class Plugin(PluginBase):
    
    def __init__ (self):
        self.name = "Bash"
        self.icon = None

    
    def sync(self):
        ''' get simple list of installed apps 
        to search for config files '''
        search_string = commands.getoutput("dpkg --get-selections '*'")
        if search_string.find("bash") != -1:
            ''' write the bash config to a couchdb '''
            with open(BASH_CONFIG, 'r') as bash:
                br = bash.read()
            #print br #debug


            record_six = CouchRecord({  "_id"       :  "bash"   ,  
                                        "profile"   :  "user001" ,
                                        "type"      :  "dotfile" ,
                                        "file"      :  br        ,
                                     },
                                     record_type = RECORD_TYPE)

            databaserecord = database.put_record(record_six)
            bash.close()
        else:
            print "Bash it's not even installed SUCKER!"
            return

    def restore(self):
        map_js2 = 'function(doc){if (doc._id == "bash"){emit(null,doc.file);}}'
        database.add_view("bashconfig", map_js2, None, "getfile")
        result = database.execute_view("bashconfig", "getfile")

        for row in result:
            config_iter = row.value

        bash_file = open(os.path.expanduser("~") + "/.bashrc2", 'w')
        bash_file.write(config_iter)
        bash_file.close()

