#!/usr/bin/env python
# -*- coding: utf-8 -*-

"""DocString

DocString Paragraph

"""

import os
import commands
from desktopcouch.records.server import CouchDatabase
from desktopcouch.records.record import Record as CouchRecord
from core.stipple import PluginBase

database = CouchDatabase("packages", create=True)
databaserecord = ""
RECORD_TYPE = 'http://www.okiebuntu.homelinux.com/packagesync'
EMACS_CONFIG = os.path.expanduser("~") + "/.emacs"

class Plugin(PluginBase):
    def __init__(self):
        self.name = "Emacs"
        self.icon = None        

    def sync(self):
        ''' get simple list of installed apps to search for config files '''
        search_string = commands.getoutput("dpkg --get-selections '*'")
        ## write the emacs config to a couchDB ##
        if search_string.find("emacs") != -1:
            with open(EMACS_CONFIG, 'r') as emacs:
                er = emacs.read()
            print er


            record_three = CouchRecord({  "_id"       :  "emacs"   ,  
                                          "profile"   :  "user001" ,
                                          "type"      :  "dotfile" ,
                                          "file"      :  er        ,
                                       },
                                     record_type = RECORD_TYPE)

            databaserecord = database.put_record(record_three)
            emacs.close()
        else:
            print "Emacs is not installed SUCKER!"
            return

    def restore(self):
        map_js2 = 'function(doc){if (doc._id == "emacs"){emit(null,doc.file);}}'
        database.add_view("emacsconfig", map_js2, None, "getfile")
        result = database.execute_view("emacsconfig", "getfile")

        for row in result:
            config_iter = row.value
            print config_iter
        emacs_file = open(os.path.expanduser("~") + "/.emacs2", 'w')
        emacs_file.write(config_iter)
        emacs_file.close()

        
