#!/usr/bin/env python
# -*- coding: utf-8 -*-

"""DocString

DocString Paragraph

"""

__version__ = "$Revision$"

import os
import commands
from desktopcouch.records.server import CouchDatabase
from desktopcouch.records.record import Record as CouchRecord
from core.stipple import PluginBase

database = CouchDatabase("packages", create=True)
databaserecord = ""
RECORD_TYPE = 'http://www.okiebuntu.homelinux.com/packagesync'
ZSH_CONFIG = os.path.expanduser("~") + "/.zshrc"

class Plugin(PluginBase):
    def __init__(self):
        self.name = "Zshrc"
        self.icon = None

    def sync(self):
        ''' get simple list of installed apps to search for config files '''
        search_string = commands.getoutput("dpkg --get-selections '*'")
        if search_string.find("zsh") != -1:
            ''' write the zsh config to a couchdb '''
            with open(ZSH_CONFIG, 'r') as zsh:
                zr = zsh.read()
            print zr


            record_five = CouchRecord({  "_id"       :  "zsh"   ,  
                                        "profile"   :  "user001" ,
                                        "type"      :  "dotfile" ,
                                        "file"      :  zr        ,
                                     },
                                     record_type = RECORD_TYPE)

            databaserecord = database.put_record(record_five)
            zsh.close()
        else:
            print "Zsh is not installed SUCKER!"
            return

    def restore(self):
        map_js2 = 'function(doc){if (doc._id == "zsh"){emit(null,doc.file);}}'
        database.add_view("zshconfig", map_js2, None, "getfile")
        result = database.execute_view("zshconfig", "getfile")

        for row in result:
            config_iter = row.value

        zsh_file = open(os.path.expanduser("~") + "/.zshrc2", 'w')
        zsh_file.write(config_iter)
        zsh_file.close() 
     
